---
title: XPathResult.snapshotItem()
slug: Web/API/XPathResult/snapshotItem
tags:
  - API
  - DOM XPath API
  - Method
  - Reference
  - XPath
  - XPathResult
---
<div>{{APIRef("DOM XPath")}}</div>

<p>The <strong><code>snapshotItem()</code></strong> method of the {{domxref("XPathResult")}} interface returns an item of the snapshot collection or <code>null</code> in case the index is not within the range of nodes. Unlike the iterator result, the snapshot does not become invalid, but may not correspond to the current document if it is mutated.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>node</var> = <var>result</var>.snapshotItem(i);
</pre>

<h3 id="Return_Value">Return value</h3>

<p>The {{domxref("Node")}} at the given index within the node set of the <code>XPathResult</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<h4 id="TYPE_ERR">TYPE_ERR</h4>

<p>In case {{domxref("XPathResult.resultType")}} is not <code>UNORDERED_NODE_SNAPSHOT_TYPE</code> or <code>ORDERED_NODE_SNAPSHOT_TYPE</code>, an {{domxref("XPathException")}} of type <code>TYPE_ERR</code> is thrown.</p>

<h2 id="Example">Example</h2>

<p>The following example shows the use of the <code>snapshotItem()</code> method.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;div&gt;XPath example&lt;/div&gt;
&lt;div&gt;Tag names of the matched nodes: &lt;output&gt;&lt;/output&gt;&lt;/div&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">var xpath = "//div";
var result = document.evaluate(xpath, document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
var node = null;
var tagNames = [];
for(var i = 0; i &lt; result.snapshotLength; i++) {
  var node = result.snapshotItem(i);
  tagNames.push(node.localName);
}
document.querySelector("output").textContent = tagNames.join(", ");
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example', 400, 70)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("DOM3 XPath", "xpath.html#XPathResult-snapshotItem", "XPathResult.snapshotItem()")}}</td>
   <td>{{Spec2("DOM3 XPath")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.XPathResult.snapshotItem()")}}</p>
</div>
